#pragma once

#include "UObject/Object.h"
#include "CoreMinimal.h"
#include "Misc/Optional.h"
#include "CustomRichInlineImageArguments.generated.h"

#pragma region Custom Rich Inline Image Arguments

USTRUCT()
struct FCustomRichInlineImageArguments {
	GENERATED_BODY()
public:
	UPROPERTY()
	int32 Width;
	UPROPERTY()
	int32 Height;
	UPROPERTY()
	int32 MarginTop;
	UPROPERTY()
	int32 MarginBottom;
	UPROPERTY()
	int32 MarginRight;
	UPROPERTY()
	int32 MarginLeft;
	UPROPERTY()
	float PositionX;
	UPROPERTY()
	float PositionY;
	FCustomRichInlineImageArguments(
		TOptional<int32> InWidth = TOptional<int32>(), TOptional<int32> InHeight = TOptional<int32>(),
		TOptional<int32> InMarginTop = TOptional<int32>(), TOptional<int32> InMarginBottom = TOptional<int32>(),
		TOptional<int32> InMarginRight = TOptional<int32>(), TOptional<int32> InMarginLeft = TOptional<int32>(),
		TOptional<float> InPositionX = TOptional<float>(), TOptional<float> InPositionY = TOptional<float>())
	{
		Width = InWidth.IsSet() ? InWidth.GetValue() : -1;
		Height = InHeight.IsSet() ? InHeight.GetValue() : -1;
		MarginTop = InMarginTop.IsSet() ? InMarginTop.GetValue() : 0;
		MarginBottom = InMarginBottom.IsSet() ? InMarginBottom.GetValue() : 0;
		MarginRight = InMarginRight.IsSet() ? InMarginRight.GetValue() : 0;
		MarginLeft = InMarginLeft.IsSet() ? InMarginLeft.GetValue() : 0;
		PositionX = InPositionX.IsSet() ? InPositionX.GetValue() : 0.0f;
		PositionY = InPositionY.IsSet() ? InPositionY.GetValue() : 0.0f;
	};
};

#pragma endregion